<?php
class CPartie extends \BaseController {
	private $partie;

	
	/* (non-PHPdoc)
	 * @see BaseController::index()
	 */
	public function index() {
		$this->loadView("vFooter");
		$this->viewCreateParty();
		$this->viewYourParty();
		$this->viewPartiesTerminees();
		
		// REFRESH
		echo JsUtils::execute("setInterval(function(){".JsUtils::_get("/trivia/CPartie/refreshPartie","{}", "#accordion-contentJoin")."},1000);");
		echo JsUtils::execute("setInterval(function(){".JsUtils::_get("/trivia/CPartie/refreshJoueur","{}", "#accordion-contentAdd")."},1000);");
		echo JsUtils::execute("setInterval(function(){".JsUtils::_get("/trivia/CPartie/refreshPartiesTerminees","{}", "#accordion-contentTerminees")."},1000);");
	}
	
	// ???????????????????
	// permet d'instancier une nouvel objet Partie
	private function addNew(){
		$this->partie=new Partie();		
	}
	// ???????????????????
	private function load($idPartie){
		$this->partie=DAO::getOne('Partie', $idPartie);
	}
	// ???????????????????
	private function addPlayer($joueur){
		$result=false;
		if($this->partie->getJoueur1()==null){
			$this->partie->setJoueur1($joueur);
			if(DAO::insert($this->partie)==1){
				$result=true;
			}			
		}else if($this->partie->getJoueur2()==null){
			$this->partie->setJoueurEnCours($joueur);
			$this->partie->setJoueur2($joueur);
			if(DAO::update($this->partie)==1){
				$result=true;
			}			
		}
		return $result;
	}
	
	// permet de la création de la partie
	public function simpleParty($id){
		$id=str_replace("createParty","",$id[0]);
		$partie=new Partie();
		$joueur1=$this->loadPlayer();
		$joueur2=DAO::getOne("Joueur", $id);
		if($joueur1!=null && $joueur2!=null){
			$partie->setJoueur1($joueur1);
			$partie->setJoueur2($joueur2);
			$partie->setJoueurEnCours($joueur1);
			$partie->setTermine(false);
			if(DAO::insert($partie)==1){
				echo 'Partie créée avec succès !';
				// création de la série j1
				$serie=new Serie();
				$serie->setJoueur($joueur1);
				$serie->setPartie($partie);
				$serie->setNombre(0);
				DAO::insert($serie);
				// création de la série j2
				$serie->setJoueur($joueur2);
				$serie->setPartie($partie);
				$serie->setNombre(0);
				DAO::insert($serie);
			}else{
				echo 'Une erreur est survenue, impossible de créer la partie.';
			}	
		}else{
			echo 'Une erreur est survenue, impossible de charger les joueurs.';
		}
		
	}
	
	// permet de charger l'objet Joueur representant le joueur actuel (en session)
	private function loadPlayer(){
		$joueur=null;
		if (array_key_exists('joueur', $_SESSION)){
			$joueur=$_SESSION['joueur'];			
		}
		return $joueur;
	}
	
	// ?????
	public function createParty(){
		if($this->loadPlayer()!=null){
			$joueur=$this->loadPlayer();
			$this->addNew();
			if($this->addPlayer($joueur)){
				echo 'Partie créée avec succès !';
			}else{
				echo 'Une erreur est survenue, impossible de créer la partie.';
			}			
		}
	}
	
	// permet d'afficher la vue avec les autres joueurs pour choisir un adversaire
	public function viewCreateParty(){ 
		$this->loadView("vAddParty",$this->displayJoueur());
		echo JsUtils::getAndBindTo(".trAddPartie", "click", "/trivia/CPartie/simpleParty/","{}","#messageNotif"); // simple party = creation de la partie
	}
	
	// permet de récupérer tous les joueurs du même monde que le joueur actuel ( sauf le joueur actuel )
	public function displayJoueur(){
		$joueur=$this->loadPlayer();		
		return DAO::getAll("Joueur","id <>".$joueur->getId()." AND idmonde=".$joueur->getMonde()->getId());
	}
	
	// permet de lancer la partie
	public function joinParty($id){
		$id=str_replace("joinParty","",$id[0]);
		$joueur=TriviaUtils::loadPlayer();
		$partie=DAO::getOne("Partie", $id);
		if($partie->getJoueur1()==$joueur){
			echo "Partie contre ".$partie->getJoueur2();
		}else{
			echo "Partie contre ".$partie->getJoueur1();
		}
		echo JsUtils::post("/trivia/CDomaine/index", "{idpartie:".$id."}", ".bloc_page"); // (post) envoie de l'id de la partie vers function index de CDomaine
	}
	
	// permet de rafraihir le tableau des parties
	public function refreshPartie(){
		$amdj=$this->adversairesAmdj();
		$aldj=$this->adversairesAldj();
		$this->loadView("vRefreshYourParty",array("amdj"=>$amdj,"aldj"=>$aldj));
		echo JsUtils::getAndBindTo(".lienJoin", "click", "/trivia/CPartie/joinParty/","{}","#messageNotif");
	}
	
	// permet de rafraihir le tableau des parties terminees
	public function refreshPartiesTerminees(){
		$terminees=$this->partiesTerminees();
		//rechargement de la vue
		$this->loadView("vRefreshPartiesTerminees",array("terminees"=>$terminees));
	}
	
	// permet de rafraihir le tableau des adversaires
	public function refreshJoueur(){
		$this->loadView("vRefreshAddParty",$this->displayJoueur());
		echo JsUtils::getAndBindTo(".trAddPartie", "click", "/trivia/CPartie/simpleParty/","{}","#messageNotif");
	}
	
	// permet de retourner la liste des parties ou c'est au joueur actuel de jouer
	public function adversairesAmdj(){
		$joueur=TriviaUtils::loadPlayer();
		$parties=DAO::getAll("Partie","(idJoueur1=".$joueur->getId()." OR idJoueur2=".$joueur->getId().") AND termine=0");
		$amdj=array();
		foreach($parties as $partie){
			if($partie->getJoueurEnCours()==$joueur){
				if($partie->getJoueur1()==$joueur){
					$partie->setJoueurEnCours($partie->getJoueur2());
				}else{
					$partie->setJoueurEnCours($partie->getJoueur1());
				}
				$amdj[]=$partie;
			}
		}
		return $amdj;
	}
	
	// retourne la liste des parties ou c'est à l'autre joueur de jouer
	public function adversairesAldj(){
		$joueur=TriviaUtils::loadPlayer();
		$parties=DAO::getAll("Partie","(idJoueur1=".$joueur->getId()." OR idJoueur2=".$joueur->getId().") AND termine=0");
		$aldj=array();
		foreach($parties as $partie){
			if($partie->getJoueurEnCours()!=$joueur){				
				$aldj[]=$partie;
			}
		}
		return $aldj;	
	}
	
	// permet de retourner les parties terminées du joueur et leur résultat : perdu ou gagné ?
	public function partiesTerminees(){
		$joueur=TriviaUtils::loadPlayer();
		$parties=DAO::getAll("Partie","(idJoueur1=".$joueur->getId()." OR idJoueur2=".$joueur->getId().") AND termine=1");
		$terminees=array();
		foreach($parties as $partie){
			if($partie->getJoueurEnCours()==$joueur){ // dernier joueur en cours = perdu
				if($partie->getJoueur1()==$joueur){
					$terminees[]=array("contre"=>$partie->getJoueur2(),"etat"=>"Perdu","class"=>"tdLose");
				}else{
					$terminees[]=array("contre"=>$partie->getJoueur1(),"etat"=>"Perdu","class"=>"tdLose");
				}
			}else{ // sinon gagné
				if($partie->getJoueur1()==$joueur){
					$terminees[]=array("contre"=>$partie->getJoueur2(),"etat"=>"Gagné","class"=>"tdWin");
				}else{
					$terminees[]=array("contre"=>$partie->getJoueur1(),"etat"=>"Gagné","class"=>"tdWin");
				}
			}
		}
		return $terminees;
	}
	
	// permet d'afficher la vue avec les parties en cours du joueur actuel
	public function viewYourParty(){
		$amdj=$this->adversairesAmdj();
		$aldj=$this->adversairesAldj();
		
		//chargement de la vue Mesparties
		$this->loadView("vYourParty",array("amdj"=>$amdj,"aldj"=>$aldj));
		
		//affichage partie contre notif
		echo JsUtils::getAndBindTo(".lienJoin", "click", "/trivia/CPartie/joinParty/","{}","#messageNotif");
	}
	
	// permet d'afficher la vue des parties terminées
	public function viewPartiesTerminees(){
		$terminees=$this->partiesTerminees(); 
		//chargement de la vue
		$this->loadView("vPartiesTerminees",array("terminees"=>$terminees));
	}

	 
}