<?php
class CQuestion extends \BaseController {
	private $question;
	
	public function index() {
		$this->viewPlay();
		echo JsUtils::execute("$(document).ready(ProgressBar())"); // execute la progress bar
		
	}	
	
	
	public function newQuestion($idDomaine,$libelle){
		$joueur=$this->loadPlayer();
		if($joueur!=null){
			$this->question=new Question();
			$this->question->setIdDomaine($idDomaine);
			$this->question->setIdJoueur($joueur->getId());
			$this->question->setLibelle($libelle);
			$this->question->setValidation(false);
			if(DAO::insert($this->question)==1){
				echo 'La question a été ajoutée à la base de donnée, merci pour votre engagement envers notre application, elle sera validée d\'ici peu.';
			}else{
				echo 'Impossible d\'ajouter votre question à notre base de données, veuillez réesaayer ultérieurement.';
			}
		}else{
			echo 'Impossible de charger votre profil, reconnectez vous, si le problème persiste contactez l\'administrateur.';
		}	
	}
	
	// permet de charger le joueur
	private function loadPlayer(){
		$joueur=null;
		if (array_key_exists('joueur', $_SESSION)){
			$joueur=$_SESSION['joueur'];
		}
		return $joueur;
	}
	
	private function loadQuestion($idQuestion){
		$this->question=DAO::getOne("Question", $idQuestion);
	}
	
	public function validateQuestion($idQuestion,$validate){
		$this->loadQuestion($idQuestion);
		$this->question->setValidation($validate);
		DAO::update($this->question);
	}
	
	public function modifyQuestion($idQuestion,$libelle){
		$this->loadQuestion($idQuestion);
		$this->question->setLibelle($libelle);
		DAO::update($this->question);
	}
	
	// permet de retourner une question aléatoirement
	public static function foundQuestion($domaine){
		$question=DAO::getOne("Question","iddomaine=".$domaine->getId()." ORDER BY RAND() LIMIT 1");
		if(!empty($question)){
			return $question;
		}
	}
	
	// permet de retourner id partie, idodmaine, une question et ses réponses + 
	public function loadQuestionAndAnswers(){
		if (array_key_exists('idpartie', $_POST)){  // posted par js/demo/TransitionQuestion()
			$idpartie=$_POST['idpartie'];
		}
		if (array_key_exists('iddomaine', $_POST)){  // posted par js/demo/TransitionQuestion()
			$iddomaine=$_POST['iddomaine'];
		}
		$partie=DAO::getOne("Partie", $idpartie);	
		//affichage des couronnes
		$serie=CSerie::loadSerie($partie);
		$nombreInitial=$serie->getNombre();
		switch ($nombreInitial)
		{case 1:
			//affichage couronne 1
			echo JsUtils::doSomethingOn("#couronne".$nombreInitial, "removeClass","'couronne".$nombreInitial."'");
			echo JsUtils::doSomethingOn("#couronne".$nombreInitial, "addClass","'couronne".$nombreInitial."Move'");
			break;
				
		case 2:
			//affichage couronne 1 et 2		
			//couronne1
			$nombre1=$nombreInitial-1;
			echo JsUtils::doSomethingOn("#couronne".$nombre1, "removeClass","'couronne".$nombre1."'");
			echo JsUtils::doSomethingOn("#couronne".$nombre1, "addClass","'couronne".$nombre1."Move'");
			
			//couronne2
			echo JsUtils::doSomethingOn("#couronne".$nombreInitial, "removeClass","'couronne".$nombreInitial."'");
			echo JsUtils::doSomethingOn("#couronne".$nombreInitial, "addClass","'couronne".$nombreInitial."Move'");
			break;
		
		case 3:
			//affichage couronne 1,2 et 3
			//couronne 1
			$nombre1=$nombreInitial-2;
			echo JsUtils::doSomethingOn("#couronne".$nombre1, "removeClass","'couronne".$nombre1."'");
			echo JsUtils::doSomethingOn("#couronne".$nombre1, "addClass","'couronne".$nombre1."Move'");
			
			//couronne 2
			$nombre2=$nombreInitial-1;
			echo JsUtils::doSomethingOn("#couronne".$nombre2, "removeClass","'couronne".$nombre2."'");
			echo JsUtils::doSomethingOn("#couronne".$nombre2, "addClass","'couronne".$nombre2."Move'");
			
			//couronne 3
			echo JsUtils::doSomethingOn("#couronne".$nombreInitial, "removeClass","'couronne".$nombreInitial."'");
			echo JsUtils::doSomethingOn("#couronne".$nombreInitial, "addClass","'couronne".$nombreInitial."Move'");
			
			break;	
		}
		
		// fin affichage couronnes : retourne id partie, id domaine, une question et ses réponses
		$domaine=DAO::getOne("Domaine", $iddomaine);
		$question=CQuestion::foundQuestion($domaine);
		$reponses=CReponse::loadAnswers($question->getId());
		return array("idpartie"=>$idpartie,"iddomaine"=>$iddomaine,"question"=>$question,"reponses"=>$reponses);
	}
	
	// permet de charger la question et ses réponses
	public function viewPlay(){		
		$this->loadView("vQuestion",$this->loadQuestionAndAnswers());
		if (array_key_exists('idpartie', $_POST)){
			$idpartie=$_POST['idpartie'];
		}	
		echo JsUtils::getAndBindTo(".answer", "click","/trivia/CQuestion/answerChoosen/".$idpartie, "{}","#jQuery");
	}
	
	// appel de la function par le menu question : permet de charger la vue MesQuestions et de lister les questions du joueurs par domaine
	public function viewGestionQuestion(){
		$joueur=TriviaUtils::loadPlayer();
		$monde=$joueur->getMonde();
		$domaines=DAO::getAll("Domaine","idmonde='".$monde->getId()."'");
		$questions=DAO::getAll("Question","idjoueur='".$joueur->getId()."'");
		$result=array();
		foreach ($questions as $question){
			$result[$question->getDomaine()->getLibelle()]["domaine"]=$question->getDomaine();
			$result[$question->getDomaine()->getLibelle()]["questions"][]=$question;
		}
		$this->loadView("vGestionQuestions", array("monde"=>$monde,"domaines"=>$domaines,"result"=>$result));
	}
	
	// permet de vérifier le résultat de la réponse choisie : d'incrémenter les stats, les séries, de crée la couronne; afficher le résultat vert/rouge
	public function answerChoosen($id){		
		$partie=DAO::getOne("Partie", $id[0]);
		date_default_timezone_set("Europe/Paris");
		$partie->setDernierCoup(date("Y-m-d H:i:s"));
		$joueur=TriviaUtils::loadPlayer();
		$idReponse=str_replace("answer","",$id[1]);	
		$domaine=CReponse::loadAnswer($idReponse)->getQuestion()->getDomaine();
		if(CReponse::checkAnswer($idReponse)){		// si bonne réponse	
			CStatistiques::incStats($domaine);
			CSerie::incScore($partie,$domaine);
			echo JsUtils::doSomethingOn("#answer".$idReponse,"css","'background', '#73E95C'"); // color green rep clicked
		}else{ // mauvaise réponse
			if($partie->getJoueur1()==$joueur){
				$partie->setJoueurEnCours($partie->getJoueur2());
			}else{
				$partie->setJoueurEnCours($partie->getJoueur1());
			}
			CStatistiques::incStats($domaine,false);
			echo JsUtils::doSomethingOn("#answer".$idReponse,"css","'background', '#d9534f'"); // color red reponse clicked
			echo JsUtils::doSomethingOn("#answer".CReponse::goodAnswer($idReponse),"css","'background', '#73E95C'"); // color green bonne reponse
		}
		DAO::update($partie);
	}
	
	// permet de changer le tour de jeu des joueurs
	public static function changePlayer($id){
		$partie=DAO::getOne("Partie", $id[0]);
		$domaine=DAO::getOne("Domaine", $id[1]);
		CStatistiques::incStats($domaine,false);
		$joueur=TriviaUtils::loadPlayer();
		if($partie->getJoueur1()==$joueur){
			$partie->setJoueurEnCours($partie->getJoueur2());
		}else{
			$partie->setJoueurEnCours($partie->getJoueur1());
		}
		DAO::update($partie);
	}
	
	
	
	// appel via la vue vGestionQuestions : permet d'ajouter une question et ses réponses dans la bdd
	public function addQuestion(){
		$domaine=DAO::getOne("domaine", $_POST["domaine"]);
		$libelle=$_POST["libelle"];
		$joueur=$this->loadPlayer();
		
		if($joueur!=null){
			$this->question=new Question();
			$this->question->setDomaine($domaine);
			$this->question->setJoueur($joueur);
			$this->question->setLibelle($libelle);
			
			if(DAO::insert($this->question)==1){
				$success=true;
				// get la question
				//$question=DAO::getOne("question", $this->question->getId())
				// ajout des réponses	
				$libelleRep1=$_POST["rep1"];
				$libelleRep2=$_POST["rep2"];
				$libelleRep3=$_POST["rep3"];
				$libelleRep4=$_POST["repValid"];
				$i=1;
				for($i;$i<5;$i++){
					${"rep".$i}=new Reponse();
					${"rep".$i}->setLibelle(${"libelleRep".$i});
					${"rep".$i}->setQuestion($this->question);
					if($i==4){
						${"rep".$i}->setIsTrue(1);
					}				
					if(DAO::insert(${"rep".$i})!=1){
						$success=false;
					}
				}
				if($success){
					echo "Question ajoutée !";
				}else{
					echo "Echec de l'ajout des réponses";
				}
			}else{
				echo "Echec de l'ajout";
			}
		}else{
			echo "Vous n'êtes pas connecté";
		}	
	}
	
	
	// appel via la vue vGestionQuestions : permet de retourner la question et ses réponses en jquery vers le callback de load Edit
	public function loadEdit($id){
		$id=$id[0];
		$question=DAO::getOne("Question", $id);
		$reponses=DAO::getAll("Reponse","idquestion='".$id."'");
		$result=array();
		$result["libelle"]=$question->getLibelle();
		$result["domaine"]=$question->getDomaine()->getId();
		$i=1;
		foreach ($reponses as $reponse){
			if($reponse->getIsTrue()==1){
				$result["repValid"]=$reponse->getLibelle();
			}else{
				$result["rep".$i]=$reponse->getLibelle();
				$i++;
			}
		}		
		echo json_encode($result);
	}
	
	// appel via la vue vGestionQuestions : permet de retourner le resultat de la suppresiond de la question passé en param
	public function delete($id){
		$id=$id[0];
		$question=DAO::getOne("Question", $id);
		if(DAO::delete($question)==1){
			$result=array("valid"=>true,"text"=>"Question supprimée !");
		}else{
			$result=array("valid"=>false,"text"=>"Suppression impossible");
		}
		echo json_encode($result);
	}
}